#include <stdio.h>

#define MAXSIZE 10

FILE *in;

int check(int a[MAXSIZE][MAXSIZE], int n)
{
    int sum1, sum2, gsum;
    int i, j;

    gsum = -1;

    for (i = 0; i < n; ++i) {
	sum1 = sum2 = 0;
	for (j = 0; j < n; ++j) {
	    sum1 += a[i][j];
	    sum2 += a[j][i];
	}
	if (gsum == -1)
	    gsum = sum1;
	if (gsum != sum1 || gsum != sum2)
	    return 0;
    }

    sum1 = 0; sum2 = 0;
    for (i = 0; i < n; ++i) {
	sum1 += a[i][i];
	sum2 += a[i][n-i-1];
    }
    if (gsum != sum1 || gsum != sum2)
	return 0;

    return 1;
}
   

int main(int argc, char *argv[])
{
    int i = 1;
    int x, y;
    int  var;
    int a[MAXSIZE][MAXSIZE];

    in = fopen("magic.in", "r");

    while (1) {
	fscanf(in, "%d", &var);

	if (var > 0) {
	    for (x = 0; x < var; ++x)
		for (y = 0; y < var; ++y)
		    fscanf(in, "%d", &(a[x][y]));

	    printf("Square #%d:\n", i);
	    if (check(a, var))
		printf("This square is magic.\n\n");
	    else
		printf("This square is not magic.\n\n");

	    ++i;
	}
	else
	    break;
    }

    fclose(in);
    return 0;
}
	
